/***********************************************************************/
/*  IIC-Interface  Testprogramm f. TSA5511		               */
/*  V0.1  erstellt am  : 07.05.2001 / I. Gerlach                       */
/*  Dateiname          : test_tsa.c				       */
/*                                     				       */
/*  Aenderungen : 						       */
/*                                                                     */
/*                                                                     */
/* 					                               */
/* *********************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include "../i2c_ser/i2c_ser.h" 		// i2c Funktionen
//#include "../src/lcd.h"
#include "tsa5511.h"


int main(int argc, char *argv[]) {

 int test;
 int opt;
 int Adresse = 6; // Adresse = 6 = 198 Wobbler, 2 = Sat Tuner Mitel SP5055
int b = 0;
 
  // long f = 106900000;
   long f =   1239250000 ;
  
   while((opt=getopt(argc, argv, ":f:")) != EOF)
    switch(opt)
   {
 
    case 'f':
     f=atol(optarg);
     break;
   }  
       
 printf("*** ic-TSA5511 Test (c) Ingo Gerlach 05/2001 *** \n");
 set_port_delay(10);		// Portdelay 0-255 
 test = init_iic(0);		// Init ii2c 0, automatisch suchen
 printf("Suche i2c-Interface...");
 if (test) 
 {
  printf(" gefunden an Port 0x%03xh! \n",test);
 } else {
    printf("Interface nicht gefunden.\n");
    exit (0);
  }
//  set_strobe(1);			// Fr den Seriellen Port nur dummy, Parport -> wichtig !!! 
//  io_disable();				// 8 Bit I/O disablen auch nur ParPort
 
  test = tsa5511_init(&tsa5511,TSA5511_PLL,4000000);  // Daten initialisieren Datenstruktur, 
  				

  printf(" Init %d \n",tsa5511.cnt1);  						  
  test  = tsa5511_calc(&tsa5511,f,1);		// Berechnen der Teiler
  printf("Freq: %ld , Teiler n %d , Fres: %d\n",f,test,(test*TSA5511_STEP));
  // printf("Freq: %ld , Teiler n %d , Fres: %d\n",f,test,((test*125000)/1000000));
  printf("Step: %d \n ",tsa5511.step);
  printf("Q   : %ld \n", tsa5511.quarz);
  printf(" Div 1 : %d \n",tsa5511.div1);
  printf(" Div 2 : %d \n",tsa5511.div2);
  printf(" Cont1 : %d \n",tsa5511.cnt1);
  printf(" Cont2 : %d \n",tsa5511.cnt2);
  printf("Ret: %d \n",tsa5511_send(&tsa5511,Adresse));
  printf("Read %d \n",tsa5511_read(Adresse));

test  = tsa5511_calc(&tsa5511,f,0);		// Berechnen der Teiler
tsa5511_send(&tsa5511,Adresse);

  printf("Read %d \n",tsa5511_read(Adresse));
  sleep(2);
  printf("Read %d \n",tsa5511_read(Adresse));


  return 0;


		     
  for (f=935000000;f<1455000000;) {
   printf("%10ld \n",f);
   test  = tsa5511_calc(&tsa5511,f,0);		// Berechnen der Teiler
   tsa5511_send(&tsa5511,Adresse);
   test = tsa5511_read(Adresse);
   b = 0; 
   while (test < 64) {
    sleep(1);
    test = tsa5511_read(Adresse);
    printf("Unlock %10ld \n",f);
    b++;
    if (b==10) { test = 100; }
   }
   f=f+(1*TSA5511_STEP);
  }


  printf("deinit %d\n",deinit_iic()); 
 return 0;
}
